<?php
defined('BASEPATH') or exit('No direct script access allowed');

class ParserDatabase
{

    //TODO: Functions return void

    protected $idLicitacion = 0;
    protected $fechaInicioParser = "";

    public function __construct()
    {
        $this->CI = &get_instance();
        $this->CI->load->model("Parser_model");
    }

    public function setDatosParser($arrayDatosSucios, $fecha)
    {
        $this->fechaInicioParser = $fecha;
        if (!empty($arrayDatosSucios)) {

            foreach ($arrayDatosSucios as $nombreArchivo => $datosArchivo) {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "ARCHIVO ---" . $nombreArchivo, false);

                foreach ($datosArchivo as $row) {
                    $idLicitacion = $this->setInicioLicitacion($row['general']);

                    if ($idLicitacion['result']) {
                        $this->idLicitacion = $idLicitacion['id'];

                        $this->setContractInfo($row['contractInfo']);

                        $this->setLocatedContractingParty($row['locatedContractingParty']);

                        $this->setParty($row['party']);

                        $this->setLegalDocs($row['legalDocs']);

                        $this->setTechnicalDocs($row['technicalDocs']);

                        $this->setGeneralDocs($row['generalDocs']);

                        $this->setAdditionalDocs($row['additionalDocs']);

                    }
                }
            }
        }
    }

    private function setInicioLicitacion($datosInicioLicitacion): array
    {
        $result = array("result" => false, "id" => 0);

        $insertLicitacion = $this->CI->Parser_model->setInicioLicitacion($datosInicioLicitacion);

        if ($insertLicitacion) {
            $result = array("result" => true, "id" => $insertLicitacion);
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "Licitacion ID " . $datosInicioLicitacion['id_licitacion'] . " - BBDD Licitación ID " . $insertLicitacion, "false");
        } else {
            $result = array("result" => true, "id" => 0);
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "Licitacion ID " . $datosInicioLicitacion['id_licitacion'], "false", 2);
        }

        return $result;
    }

    private function setContractInfo($contractInfo): void
    {
        $setInsert = array();
        $resultInsert = 0;

        if (!empty($contractInfo)) {

            $contractInfo['id_ajena_licitacion'] = $this->idLicitacion;

            if ($resultInsert) {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "ContractInfo Finalizada Inserción", "false");
            } else {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "ContractInfo Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "ContractInfo vacio", "false");
        }
    }

    private function setLocatedContractingParty($contractInfo): void
    {
        $setInsert = array();
        $contractInfoInsert = 0;

        if (!empty($contractInfo)) {

            $contractInfo['locatedContractingParty']['id_ajena_licitacion'] = $this->idLicitacion;

            $contractInfoInsert = $this->CI->Parser_model->setLocatedContractInfo($contractInfo['locatedContractingParty']);

            if ($contractInfoInsert) {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "locatedContractingParty Finalizada Inserción", "false");

                if (!empty($contractInfo['activity'])) {
                    $activityArr = array();

                    foreach ($contractInfo['activity'] as $clave => $row) {
                        $activityArr[$clave] = $row;
                        $activityArr[$clave]['id_ajena_located_contracting_party'] = $contractInfoInsert;
                    }
                    $activityInsert = insertBucle($activityArr, 'BRUTO_located_contracting_party_activity', "setLicitacion_" . $this->fechaInicioParser);
                } else {
                    guardar_log("setLicitacion_" . $this->fechaInicioParser, "locatedContractingParty_Activity vacio", "false");
                }
            } else {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "locatedContractingParty Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "locatedContractingParty vacio", "false");
        }
    }

    private function setParty($partyInfo): void
    {
        $setInsert = array();
        $partyInfoInsert = 0;

        if (!empty($partyInfo)) {

            $partyInfo['party']['id_ajena_licitacion'] = $this->idLicitacion;

            $partyInfoInsert = $this->CI->Parser_model->setParty($partyInfo['party']);

            if ($partyInfoInsert) {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "PartyInfo Finalizada Inserción", "false");

                if (!empty($partyInfo['partyIdentification'])) {
                    $partyIdentificationArr = array();

                    foreach ($partyInfo['partyIdentification'] as $clave => $row) {
                        $partyIdentificationArr[$clave] = $row;
                        $partyIdentificationArr[$clave]['id_ajena_party'] = $partyInfoInsert;
                    }
                    $activityInsert = insertBucle($partyIdentificationArr, 'BRUTO_party_party_idenfitication', "setLicitacion_" . $this->fechaInicioParser);
                } else {
                    guardar_log("setLicitacion_" . $this->fechaInicioParser, "PartyInfo_PartyIdentification vacio", "false");
                }
            } else {
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "PartyInfo Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "PartyInfo vacio", "false");
        }
    }

    private function setLegalDocs($legalDocs): void
    {
        $setInsert = array();
        $resultInsert = 0;

        if (!empty($legalDocs)) {
            $aux = 0;
            foreach ($legalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_legal_documents', "setLicitacion_" . $this->fechaInicioParser);
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "LegalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "LegalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "LegalDocs vacio", "false");
        }

    }

    private function setGeneralDocs($generalDocs): void
    {
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($generalDocs)) {
            $aux = 0;
            foreach ($generalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_general_documents', "setLicitacion_" . $this->fechaInicioParser);
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "GeneralDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "GeneralDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "GeneralDocs vacio", "false");
        }

    }

    private function setAdditionalDocs($additionalDocs): void
    {
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($additionalDocs)) {
            $aux = 0;
            foreach ($additionalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_additional_documents', "setLicitacion_" . $this->fechaInicioParser);
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "AdditionalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "AdditionalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "AdditionalDocs vacio", "false");
        }
    }

    private function setTechnicalDocs($technicalDocs): void
    {
        $setInsert = array();
        $resultInsert = 0;
        if (!empty($technicalDocs)) {
            $aux = 0;
            foreach ($technicalDocs as $row) {
                $setInsert[$aux] = $row;
                $setInsert[$aux]['id_ajena_licitacion'] = $this->idLicitacion;
                $aux++;
            }

            if (!empty($setInsert)) {
                $resultInsert = insertBucle($setInsert, 'BRUTO_technical_documents', "setLicitacion_" . $this->fechaInicioParser);
            }

            if ($resultInsert) {
                $result = array("result" => true);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "TechnicalDocs Finalizada Inserción", "false");
            } else {
                $result = array("result" => true, "id" => 0);
                guardar_log("setLicitacion_" . $this->fechaInicioParser, "TechnicalDocs Fallida", "false", 2);
            }
        } else {
            guardar_log("setLicitacion_" . $this->fechaInicioParser, "TechnicalDocs vacio", "false");
        }
    }

}

/* End of file ParserSetDatabase.php */
/* Location: ./application/libraries/ParserSetDatabase.php */
